Index: Dev/branches/jQueryUI/api.php
===================================================================
--- Dev/branches/jQueryUI/api.php	(revision 246)
+++ Dev/branches/jQueryUI/api.php	(revision 247)
@@ -1,5 +1,5 @@
 <?php
 
-require_once 'classes//master.php';
+require_once 'classes/master.php';
 
 $rawInput = $HTTP_RAW_POST_DATA;
@@ -21,4 +21,5 @@
                 $user = $user_results[0];
                 if ($password == $user->password) {
+                    $output['uid'] = $user->uid;
                     $returnValue = 200;
                 }
@@ -36,15 +37,86 @@
                 $user->password = $password;
                 $user->save();
+                $output['uid'] = $user->uid;
                 $returnValue = 200;
             }
             break;
     }
+
+    if (isset($input->uid)) {
+        $user_results = User::get(array("uid" => $input->uid));
+        if (!empty($user_results)) {
+            $user = $user_results[0];
+            switch ($input->action) {
+                case "createObject":
+                    $uid = null;
+                    switch (strtolower($input->args->type)) {
+                        case "application":
+                            $newApp = new Application(null,
+                                            $input->args->values->title,
+                                            $input->args->values->description,
+                                            $input->args->values->style);
+                            $newApp->save();
+                            $uid = $newApp->uid;
+                            $returnValue = 200;
+                            break;
+                        case "survey":
+                            $newSurvey = new Survey(null,
+                                            $input->args->values->title,
+                                            $input->args->values->description,
+                                            $user, null);
+                            $newSurvey->save();
+                            $uid = $newSurvey->uid;
+                            $returnValue = 200;
+                            break;
+                        case "dashboard":
+                            //TODO
+                            break;
+                        case "question":
+                            $newQuestion = new Question(null,
+                                            $input->args->values->qCode,
+                                            $input->args->values->title,
+                                            $input->args->values->dataType,
+                                            $input->args->values->description,
+                                            $input->args->values->category,
+                                            array());
+                            $newQuestion->save();
+                            $uid = $newQuestion->uid;
+                            $returnValue = 200;
+                            break;
+                        case "session":
+                            $newSession = new Session(null,
+                                            $input->args->values->title,
+                                            $user, new DateTime(), null, null);
+                            $newSession->save();
+                            $uid = $newSession->uid;
+                            $returnValue = 200;
+                            break;
+                    }
+                    $output['uid'] = $uid;
+                    break;
+                case "getObject":
+                    $type = $input->args->type;
+                    $objects = $type::get(array("uid" => $input->args->uid));
+                    if (!empty($objects)) {
+                        $output->object = $objects[0];
+                        $returnValue = 200;
+                    }
+                    break;
+                case "getObjects":
+                    $type = $input->args->type;
+                    $output['objects'] = $type::get($input->args->predicates);
+                    $returnValue = 200;
+                    break;
+            }
+        } else {
+            $returnValue = 403;
+        }
+    }
 }
 
-header("HTTP/1.1 ".$returnValue);
+header("HTTP/1.1 " . $returnValue);
 header("Content-Type: application/json");
 header("Cache-Control: no-cache, must-revalidate");
 header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
 echo(json_encode($output));
-
 ?>
Index: Dev/branches/jQueryUI/index.php
===================================================================
--- Dev/branches/jQueryUI/index.php	(revision 246)
+++ Dev/branches/jQueryUI/index.php	(revision 247)
@@ -11,6 +11,8 @@
         <script type="text/javascript" src="js/jquery/jquery-1.7.1.js"></script>
         <script type="text/javascript" src="js/jquery/ui/jquery-ui-1.8.17.custom.js"></script>
+        <script type="text/javascript" src="js/jquery/plugins/jquery.ba-bbq.js"></script>
         <script type="text/javascript" src="js/api.js"></script>
         <script type="text/javascript" src="js/main.js"></script>
+        
         <?php new StyleSheet("visualeditors"); ?>
     </head>
@@ -23,6 +25,6 @@
             <form>
                 <fieldset>
-                    <label for="username">Name</label><input id="username" type="text" />
-                    <label for="password">Password</label><input id="password" type="text" />
+                    <label for="username">Name</label><input id="username" type="text" /><br />
+                    <label for="password">Password</label><input id="password" type="password" /><br />
                 </fieldset>
             </form>
Index: Dev/branches/jQueryUI/js/api.js
===================================================================
--- Dev/branches/jQueryUI/js/api.js	(revision 246)
+++ Dev/branches/jQueryUI/js/api.js	(revision 247)
@@ -1,41 +1,194 @@
 $(function() {
+
+    jQuery.extend({
+        getScript: function(url, callback) {
+            var d = $.Deferred();
+            if (callback)
+                d.done(callback);
+            var head = document.getElementsByTagName("head")[0];
+            var script = document.createElement("script");
+            script.src = url;
+
+            // Handle Script loading
+            {
+                var done = false;
+
+                // Attach handlers for all browsers
+                script.onload = script.onreadystatechange = function(){
+                    if ( !done && (!this.readyState ||
+                        this.readyState == "loaded" || this.readyState == "complete") ) {
+                        done = true;
+                        d.resolve();
+
+                        // Handle memory leak in IE
+                        script.onload = script.onreadystatechange = null;
+                    }
+                };
+            }
+
+            head.appendChild(script);
+
+            // We handle everything using the script element injection
+            return d;
+        }
+    });
 
     rft = {
         api: {
-            post: function(action,args,success,error) {
-                $.ajax({
+            post: function(action,args) {
+                return $.ajax({
                     type: "POST",
                     url: "api.php",
                     contentType: "application/json",
-                    data: JSON.stringify({ action:action, args:args }),
-                    success: success,
-                    error: error
+                    data: JSON.stringify({
+                        uid:rft.auth.getUid(),
+                        action:action, 
+                        args:args
+                    })
+                });
+            },
+            createObject: function(type, args) {
+                var d = $.Deferred();
+                rft.api.post("createObject",
+                {
+                    type: type,
+                    values: args
+                })
+                .done(function(data, textStatus, jqXHR) {
+                    d.resolve(data.uid);
+                })
+                .fail(function(jqXHR,textStatus,errorThrown){
+                    d.reject(); 
+                });
+                return d.promise();
+            },
+            getObject: function(type, uid, success) {
+                var d = $.Deferred();
+                rft.api.post("getObject",
+                {
+                    type: type,
+                    uid: uid
+                })
+                .done(function(data, textStatus, jqXHR) {
+                    d.resolve(data.object);
+                })
+                .fail(function(jqXHR,textStatus,errorThrown){
+                    d.reject(); 
+                });
+                return d.promise();
+            },
+            getObjects: function(type, predicates, success) {
+                var d = $.Deferred();
+                rft.api.post("getObjects",
+                {
+                    type: type,
+                    predicates: predicates
+                })
+                .done(function(data, textStatus, jqXHR) {
+                    d.resolve(data.objects);
+                })
+                .fail(function(jqXHR,textStatus,errorThrown){
+                    d.reject(); 
+                });
+                return d.promise();
+            },
+            deleteObject: function(type, uid, success) {
+                var d = $.Deferred();
+                d.reject();
+                return d.promise();
+
+            }
+        },
+        auth: new (function() {
+            var self = this;
+            var currentUid = null;
+            
+            self.login = function(username,password,success,error) {
+                var d = $.Deferred();
+                rft.api.post("login",
+                {
+                    username:username,
+                    password:password
+                })
+                .done(function(data, textStatus, jqXHR) {
+                    currentUid = data.uid;
+                    d.resolve(data.uid);
+                })
+                .fail(function(jqXHR,textStatus,errorThrown){
+                    d.reject(); 
+                });
+                return d.promise();
+            };
+            
+            self.register = function(username,password,success,error) {
+                var d = $.Deferred();
+                rft.api.post("register",
+                {
+                    username:username,
+                    password:password
+                })
+                .done(function(data, textStatus, jqXHR) {
+                    currentUid = data.uid;
+                    d.resolve(data.uid);
+                })
+                .fail(function(jqXHR,textStatus,errorThrown){
+                    d.reject(); 
+                });
+                return d.promise();
+            };
+            
+            self.getUid = function(){
+                return currentUid;
+            };
+        })(),
+        content: new (function() {
+            var self = this;
+            var current = "";
+            
+            function init() {
+                $(window).bind( 'hashchange', function(e){
+                    var url = $.bbq.getState("content");
+                    self.goTo(url);
                 });
             }
-        },
-        auth: {
-            login: function(username,password,success,error) {
-                rft.api.post("login",
-                    {username:username,password:password},
-                    function(data,textStatus,jqXHR) {
-                        success && success()
-                    },
-                    function(jqXHR,textStatus,errorThrown) {
-                        error && error()
-                    }
-                );
-            },
-            register: function(username,password,success,error) {
-                rft.api.post("register",
-                    {username:username,password:password},
-                    function(data,textStatus,jqXHR) {
-                        success && success()
-                    },
-                    function(jqXHR,textStatus,errorThrown) {
-                        error && error()
-                    }
-                );
+            
+            self.initial = function(location) {
+                if ( current ) {
+                    self.goTo(location);
+                }
+                var url = $.bbq.getState("content");
+                self.goTo(url || location);
             }
-        }
+            
+            self.goTo = function(location) {
+                if ( current == location ) {
+                    return $.when();
+                }
+                current = location;
+                var d = $.Deferred();
+                $.get("pages/"+location+"/"+location+".html")
+                .done(function(html){
+                    $("#content").html(html);
+                    $.getScript("pages/"+location+"/"+location+".js")
+                    .done(function(){
+                        d.resolve(); 
+                    })
+                    .fail(function(){
+                        d.reject(); 
+                    })
+                })
+                .fail(function(){
+                    $("#content").html("Page "+location+" not found.");
+                    d.reject();
+                }).then(function(){
+                    $.bbq.pushState({
+                        "content": location
+                    });
+                })
+                return d;
+            }
+            
+            init();
+        })()
     };
 
